package testcasesupport;

public class Main {

	public static void main(String[] args) {
		
		if(args.length != 0) {
		
			if(args[0].equals("-h") || args[0].equals("--help")) {
		
				System.err.println("To use this main, you can either run the program with no " +
				"command line arguments to run all test cases or you can specify one or more classes to test");
				System.err.println("For example:");
				System.err.println("java testcasesupport.Main testcases.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference.custom_function.CWE690_Unchecked_Return_Value_to_NULL_Pointer_Dereference__custom_function_01 testcases.CWE481_Assigning_instead_of_Comparing.bool.CWE481_Assigning_instead_of_Comparing__bool_01");
				System.exit(1);
			}
			
			/* User supplied some class names on the command line, just use those with introspection
			 *
			 * String classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
			 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
 			 * could read class names from command line or use
			 * http://sadun-util.sourceforge.net/api/org/sadun/util/
			 * ClassPackageExplorer.html
			 */

			for (String className : args) {

				try {
					
					/* String classNameWithPackage = "testcases." + className; */
					
					/* IO.writeLine("classNameWithPackage = " + classNameWithPackage); */

					Class<?> myClass = Class.forName(className);

					AbstractTestCase myObject = (AbstractTestCase) myClass
							.newInstance();

					myObject.runTest(className);

				} catch (Exception ex) {

					IO.writeLine("Could not run test for class " + className);
					ex.printStackTrace();

				}
				
				IO.writeLine(""); /* leave a blank line between classes */

			}

		} else {
		
			/* No command line args were used, we want to run every testcase */
			
			/* needed to separate these calls into other methods because
			   we were running into the size limit Java has for a single method */
			runTestCWE1();
			runTestCWE2();
			runTestCWE3();
			runTestCWE4();
			runTestCWE5();
			runTestCWE6();
			runTestCWE7();
			runTestCWE8();
			runTestCWE9();
		}			
	}

private static void runTestCWE1() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-1 */

			/* END-AUTOGENERATED-JAVA-TESTS-1 */
}

private static void runTestCWE2() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-2 */

			/* END-AUTOGENERATED-JAVA-TESTS-2 */
}

private static void runTestCWE3() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-3 */

			/* END-AUTOGENERATED-JAVA-TESTS-3 */
}

private static void runTestCWE4() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-4 */

			/* END-AUTOGENERATED-JAVA-TESTS-4 */
}

private static void runTestCWE5() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-5 */

			/* END-AUTOGENERATED-JAVA-TESTS-5 */
}

private static void runTestCWE6() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-6 */
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_01()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_01");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_02()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_02");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_03()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_03");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_04()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_04");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_05()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_05");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_06()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_06");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_07()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_07");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_08()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_08");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_09()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_09");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_10()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_10");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_11()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_11");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_12()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_12");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_13()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_13");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_14()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_14");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_15()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_15");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_16()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_16");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_17()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_17");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_19()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_19");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_31()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_31");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_41()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_41");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_42()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_42");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_45()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_45");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_51a()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_51a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_52a()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_52a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_53a()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_53a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_54a()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_54a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_61a()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_61a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_66a()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_66a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_67a()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_67a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_68a()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_68a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_StringBuilder_71a()).runTest("CWE690_NULL_Deref_from_Return__Class_StringBuilder_71a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_01()).runTest("CWE690_NULL_Deref_from_Return__Class_String_01");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_02()).runTest("CWE690_NULL_Deref_from_Return__Class_String_02");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_03()).runTest("CWE690_NULL_Deref_from_Return__Class_String_03");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_04()).runTest("CWE690_NULL_Deref_from_Return__Class_String_04");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_05()).runTest("CWE690_NULL_Deref_from_Return__Class_String_05");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_06()).runTest("CWE690_NULL_Deref_from_Return__Class_String_06");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_07()).runTest("CWE690_NULL_Deref_from_Return__Class_String_07");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_08()).runTest("CWE690_NULL_Deref_from_Return__Class_String_08");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_09()).runTest("CWE690_NULL_Deref_from_Return__Class_String_09");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_10()).runTest("CWE690_NULL_Deref_from_Return__Class_String_10");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_11()).runTest("CWE690_NULL_Deref_from_Return__Class_String_11");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_12()).runTest("CWE690_NULL_Deref_from_Return__Class_String_12");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_13()).runTest("CWE690_NULL_Deref_from_Return__Class_String_13");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_14()).runTest("CWE690_NULL_Deref_from_Return__Class_String_14");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_15()).runTest("CWE690_NULL_Deref_from_Return__Class_String_15");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_16()).runTest("CWE690_NULL_Deref_from_Return__Class_String_16");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_17()).runTest("CWE690_NULL_Deref_from_Return__Class_String_17");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_19()).runTest("CWE690_NULL_Deref_from_Return__Class_String_19");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_31()).runTest("CWE690_NULL_Deref_from_Return__Class_String_31");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_41()).runTest("CWE690_NULL_Deref_from_Return__Class_String_41");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_42()).runTest("CWE690_NULL_Deref_from_Return__Class_String_42");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_45()).runTest("CWE690_NULL_Deref_from_Return__Class_String_45");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_51a()).runTest("CWE690_NULL_Deref_from_Return__Class_String_51a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_52a()).runTest("CWE690_NULL_Deref_from_Return__Class_String_52a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_53a()).runTest("CWE690_NULL_Deref_from_Return__Class_String_53a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_54a()).runTest("CWE690_NULL_Deref_from_Return__Class_String_54a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_61a()).runTest("CWE690_NULL_Deref_from_Return__Class_String_61a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_66a()).runTest("CWE690_NULL_Deref_from_Return__Class_String_66a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_67a()).runTest("CWE690_NULL_Deref_from_Return__Class_String_67a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_68a()).runTest("CWE690_NULL_Deref_from_Return__Class_String_68a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Class_String_71a()).runTest("CWE690_NULL_Deref_from_Return__Class_String_71a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_01()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_01");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_02()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_02");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_03()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_03");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_04()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_04");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_05()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_05");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_06()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_06");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_07()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_07");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_08()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_08");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_09()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_09");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_10()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_10");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_11()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_11");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_12()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_12");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_13()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_13");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_14()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_14");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_15()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_15");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_16()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_16");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_17()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_17");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_19()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_19");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_31()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_31");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_41()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_41");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_42()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_42");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_45()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_45");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_51a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_51a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_52a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_52a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_53a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_53a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_54a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_54a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_61a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_61a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_66a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_66a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_67a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_67a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_68a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_68a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_71a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_equals_71a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_01()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_01");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_02()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_02");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_03()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_03");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_04()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_04");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_05()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_05");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_06()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_06");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_07()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_07");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_08()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_08");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_09()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_09");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_10()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_10");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_11()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_11");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_12()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_12");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_13()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_13");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_14()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_14");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_15()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_15");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_16()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_16");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_17()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_17");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_19()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_19");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_31()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_31");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_41()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_41");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_42()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_42");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_45()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_45");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_51a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_51a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_52a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_52a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_53a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_53a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_54a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_54a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_61a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_61a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_66a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_66a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_67a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_67a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_68a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_68a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_71a()).runTest("CWE690_NULL_Deref_from_Return__Properties_getProperty_trim_71a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_01()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_01");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_02()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_02");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_03()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_03");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_04()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_04");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_05()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_05");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_06()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_06");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_07()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_07");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_08()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_08");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_09()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_09");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_10()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_10");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_11()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_11");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_12()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_12");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_13()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_13");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_14()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_14");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_15()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_15");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_16()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_16");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_17()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_17");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_19()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_19");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_31()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_31");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_41()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_41");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_42()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_42");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_45()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_45");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_51a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_51a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_52a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_52a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_53a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_53a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_54a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_54a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_61a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_61a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_66a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_66a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_67a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_67a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_68a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_68a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_equals_71a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_equals_71a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_01()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_01");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_02()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_02");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_03()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_03");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_04()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_04");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_05()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_05");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_06()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_06");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_07()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_07");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_08()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_08");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_09()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_09");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_10()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_10");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_11()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_11");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_12()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_12");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_13()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_13");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_14()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_14");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_15()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_15");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_16()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_16");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_17()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_17");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_19()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_19");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_31()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_31");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_41()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_41");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_42()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_42");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_45()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_45");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_51a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_51a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_52a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_52a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_53a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_53a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_54a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_54a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_61a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_61a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_66a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_66a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_67a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_67a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_68a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_68a");
			(new testcases.CWE690_NULL_Deref_from_Return.CWE690_NULL_Deref_from_Return__System_getProperty_trim_71a()).runTest("CWE690_NULL_Deref_from_Return__System_getProperty_trim_71a");
			/* END-AUTOGENERATED-JAVA-TESTS-6 */
}

private static void runTestCWE7() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-7 */

			/* END-AUTOGENERATED-JAVA-TESTS-7 */
}

private static void runTestCWE8() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-8 */

			/* END-AUTOGENERATED-JAVA-TESTS-8 */
}

private static void runTestCWE9() {
/* BEGIN-AUTOGENERATED-JAVA-TESTS-9 */

			/* END-AUTOGENERATED-JAVA-TESTS-9 */
}
}